diff --git a/src/main/java/net/minecraft/core/entity/monster/EntityCreeper.java b/src/main/java/net/minecraft/core/entity/monster/CreeperMob.java
similarity index 86%
rename from src/main/java/net/minecraft/core/entity/monster/EntityCreeper.java
rename to src/main/java/net/minecraft/core/entity/monster/CreeperMob.java
index 7945ea533..d0a4ba07c 100644
--- a/src/main/java/net/minecraft/core/entity/monster/EntityCreeper.java
+++ b/src/main/java/net/minecraft/core/entity/monster/CreeperMob.java
@@ -2,32 +2,33 @@ package net.minecraft.core.entity.monster;
 
 // Referenced classes of package net.minecraft.src:
 //            EntityMob, DataWatcher, NBTTagCompound, World, 
-//            EntitySkeleton, Item, Entity, EntityLightningBolt
+//            SkeletonMob, Item, Entity, LightningEntity
 
 import net.minecraft.core.WeightedRandomLootObject;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.EntityLightningBolt;
+import net.minecraft.core.entity.LightningEntity;
 import net.minecraft.core.item.Item;
+import net.minecraft.core.item.Items;
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.world.World;
 
-public class EntityCreeper extends EntityMonster
+public class CreeperMob extends Monster
 {
 
-    public EntityCreeper(World world)
+    public CreeperMob(World world)
     {
         super(world);
         textureIdentifier = new NamespaceID("minecraft", "creeper");
         scoreValue = 800;
         setSize(0.6F, 1.6F);
-        mobDrops.add(new WeightedRandomLootObject(Item.sulphur.getDefaultStack(), 0, 2));
+        mobDrops.add(new WeightedRandomLootObject(Items.SULPHUR.getDefaultStack(), 0, 2));
     }
 
     @Override
-	protected void init()
+	protected void defineSynchedData()
     {
-        super.init();
+        super.defineSynchedData();
         entityData.define(16, (byte) -1);
         entityData.define(17, (byte) 0);
     }
@@ -110,9 +111,9 @@ public class EntityCreeper extends EntityMonster
 	public void onDeath(Entity entityKilledBy)
     {
         super.onDeath(entityKilledBy);
-        if(entityKilledBy instanceof EntitySkeleton)
+        if(entityKilledBy instanceof SkeletonMob)
         {
-            spawnAtLocation(Item.record13.id + random.nextInt(11), 1);
+            spawnAtLocation(Items.RECORD_13.id + random.nextInt(11), 1);
         }
     }
 
@@ -162,9 +163,9 @@ public class EntityCreeper extends EntityMonster
         return entityData.getByte(17) == 1;
     }
 
-    public float setCreeperFlashTime(float f)
+    public float getSwelling(float partialTick)
     {
-        return ((float)lastActiveTime + (float)(timeSinceIgnited - lastActiveTime) * f) / 28F;
+        return ((float)lastActiveTime + (float)(timeSinceIgnited - lastActiveTime) * partialTick) / 28F;
     }
 
     private int getCreeperState()
@@ -178,7 +179,7 @@ public class EntityCreeper extends EntityMonster
     }
 
     @Override
-	public void thunderHit(EntityLightningBolt bolt)
+	public void thunderHit(LightningEntity bolt)
     {
         super.thunderHit(bolt);
         entityData.set(17, Byte.valueOf((byte)1));
diff --git a/src/main/java/net/minecraft/core/entity/monster/Enemy.java b/src/main/java/net/minecraft/core/entity/monster/Enemy.java
new file mode 100644
index 000000000..a644bf256
--- /dev/null
+++ b/src/main/java/net/minecraft/core/entity/monster/Enemy.java
@@ -0,0 +1,9 @@
+package net.minecraft.core.entity.monster;
+
+
+import net.minecraft.core.entity.animal.Creature;
+
+public interface Enemy
+	extends Creature
+{
+}
diff --git a/src/main/java/net/minecraft/core/entity/monster/EntityGhast.java b/src/main/java/net/minecraft/core/entity/monster/GhastMob.java
similarity index 73%
rename from src/main/java/net/minecraft/core/entity/monster/EntityGhast.java
rename to src/main/java/net/minecraft/core/entity/monster/GhastMob.java
index e3f7c39bd..90fee0c59 100644
--- a/src/main/java/net/minecraft/core/entity/monster/EntityGhast.java
+++ b/src/main/java/net/minecraft/core/entity/monster/GhastMob.java
@@ -1,47 +1,56 @@
 package net.minecraft.core.entity.monster;
 
 // Referenced classes of package net.minecraft.src:
-//            EntityFlying, IMob, DataWatcher, World, 
-//            MathHelper, Entity, AxisAlignedBB, EntityFireball, 
+//            FlyingMob, IMob, DataWatcher, World,
+//            MathHelper, Entity, AxisAlignedBB, FireballProjectile,
 //            Vec3D, Item
 
 import net.minecraft.core.WeightedRandomLootObject;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.entity.projectile.FireballProjectile;
 import net.minecraft.core.util.collection.NamespaceID;
-import net.minecraft.core.util.phys.Vec3d;
+import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.projectile.EntityFireball;
-import net.minecraft.core.entity.EntityFlying;
-import net.minecraft.core.entity.player.EntityPlayer;
-import net.minecraft.core.item.Item;
+import net.minecraft.core.entity.FlyingMob;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.util.helper.DamageType;
 
-public class EntityGhast extends EntityFlying
-    implements IEnemy
+public class GhastMob extends FlyingMob
+    implements Enemy
 {
+    public int courseChangeCooldown;
+    public double waypointX;
+    public double waypointY;
+    public double waypointZ;
+    private Entity targetedEntity;
+    private int aggroCooldown;
+    public int attackChargeO;
+    public int attackCharge;
+
 
-    public EntityGhast(World world)
+    public GhastMob(World world)
     {
         super(world);
         courseChangeCooldown = 0;
         targetedEntity = null;
         aggroCooldown = 0;
-        prevAttackCounter = 0;
-        attackCounter = 0;
+        attackChargeO = 0;
+        attackCharge = 0;
         textureIdentifier = new NamespaceID("minecraft", "ghast");
         setSize(4F, 7F);
         fireImmune = true;
         scoreValue = 1000;
-        bb.expand(2F, 3F, 2F);
-        mobDrops.add(new WeightedRandomLootObject(Item.sulphur.getDefaultStack(), 0, 2));
+        bb.grow(2F, 3F, 2F);
+        mobDrops.add(new WeightedRandomLootObject(Items.SULPHUR.getDefaultStack(), 0, 2));
     }
 
     @Override
-	protected void init()
+	protected void defineSynchedData()
     {
-        super.init();
+        super.defineSynchedData();
         entityData.define(16, Byte.valueOf((byte)0));
     }
 
@@ -77,40 +86,40 @@ public class EntityGhast extends EntityFlying
         if(world.isClientSide)
         {
             byte i = entityData.getByte(16);
-            if(i > 0 && attackCounter == 0)
+            if(i > 0 && attackCharge == 0)
             {
                 world.playSoundAtEntity(null, this, "mob.ghast.charge", getSoundVolume(), (random.nextFloat() - random.nextFloat()) * 0.2F + 1.0F);
             }
-            attackCounter += i;
-            if(attackCounter < 0)
+            attackCharge += i;
+            if(attackCharge < 0)
             {
-                attackCounter = 0;
+                attackCharge = 0;
             }
-            if(attackCounter >= 20)
+            if(attackCharge >= 20)
             {
-                attackCounter = 20;
+                attackCharge = 20;
             }
-            if(attackCounter >= 20 && i == 0){
+            if(attackCharge >= 20 && i == 0){
                 world.playSoundAtEntity(null, this, "mob.ghast.fireball", getSoundVolume(), (random.nextFloat() - random.nextFloat()) * 0.2F + 1.0F);
-                attackCounter = -40;
+                attackCharge = -40;
             }
         }
         super.tick();
     }
 
     @Override
-	protected void updatePlayerActionState()
+	protected void updateAI()
     {
         if(!world.isClientSide && world.difficultySetting == 0)
         {
             remove();
         }
         tryToDespawn();
-        prevAttackCounter = attackCounter;
+        attackChargeO = attackCharge;
         double d = waypointX - x;
         double d1 = waypointY - y;
         double d2 = waypointZ - z;
-        double d3 = MathHelper.sqrt_double(d * d + d1 * d1 + d2 * d2);
+        double d3 = MathHelper.sqrt(d * d + d1 * d1 + d2 * d2);
         if(d3 < 1.0D || d3 > 60D)
         {
             waypointX = x + (double)((random.nextFloat() * 2.0F - 1.0F) * 16F);
@@ -139,7 +148,7 @@ public class EntityGhast extends EntityFlying
         if(targetedEntity == null || aggroCooldown-- <= 0)
         {
             targetedEntity = world.getClosestPlayerToEntity(this, 100D);
-            if (targetedEntity != null && !((EntityPlayer) targetedEntity).getGamemode().areMobsHostile())
+            if (targetedEntity != null && !((Player) targetedEntity).getGamemode().areMobsHostile())
             {
             	targetedEntity = null;
             }
@@ -152,50 +161,50 @@ public class EntityGhast extends EntityFlying
         if(targetedEntity != null && targetedEntity.distanceToSqr(this) < d4 * d4)
         {
             double d8 = 4D;
-            Vec3d vec3d = getViewVector(1.0F);
+            Vec3 vec3 = getViewVector(1.0F);
             double dX = targetedEntity.x - x;
             double dY = targetedEntity.y - y;
             double dZ = targetedEntity.z - z;
-            double dist = MathHelper.sqrt_double(dX * dX + dY * dY + dZ * dZ);
-            double vX = dX + (targetedEntity.xd * dist/7.5d) - vec3d.xCoord * d8;
+            double dist = MathHelper.sqrt(dX * dX + dY * dY + dZ * dZ);
+            double vX = dX + (targetedEntity.xd * dist/7.5d) - vec3.x * d8;
             double vY = dY + (targetedEntity.yd * dist/7.5d) - ((double)(bbHeight / 2.0F) + 0.5D);
-            double vZ = dZ + (targetedEntity.zd * dist/7.5d) - vec3d.zCoord * d8;
-            renderYawOffset = yRot = (-(float) java.lang.Math.atan2(vX, vZ) * 180F) / MathHelper.PI;
+            double vZ = dZ + (targetedEntity.zd * dist/7.5d) - vec3.z * d8;
+            yBodyRot = yRot = (-(float) java.lang.Math.atan2(vX, vZ) * 180F) / MathHelper.PI;
             if(canEntityBeSeen(targetedEntity))
             {
-                if(attackCounter == 10)
+                if(attackCharge == 10)
                 {
                     world.playSoundAtEntity(null, this, "mob.ghast.charge", getSoundVolume(), (random.nextFloat() - random.nextFloat()) * 0.2F + 1.0F);
                 }
-                attackCounter++;
-                if(attackCounter == 20)
+                attackCharge++;
+                if(attackCharge == 20)
                 {
                     world.playSoundAtEntity(null, this, "mob.ghast.fireball", getSoundVolume(), (random.nextFloat() - random.nextFloat()) * 0.2F + 1.0F);
-                    EntityFireball entityfireball = new EntityFireball(world, this, vX, vY, vZ);
+                    FireballProjectile entityfireball = new FireballProjectile(world, this, vX, vY, vZ);
 
-                    entityfireball.x = x + vec3d.xCoord * d8;
+                    entityfireball.x = x + vec3.x * d8;
                     entityfireball.y = y + (double)(bbHeight / 2.0F) + 0.5D;
-                    entityfireball.z = z + vec3d.zCoord * d8;
+                    entityfireball.z = z + vec3.z * d8;
                     world.entityJoinedWorld(entityfireball);
-                    attackCounter = -40;
+                    attackCharge = -40;
                 }
             } else
-            if(attackCounter > 0)
+            if(attackCharge > 0)
             {
-                attackCounter--;
+                attackCharge--;
             }
         } else
         {
-            renderYawOffset = yRot = (-(float) java.lang.Math.atan2(xd, zd) * 180F) / 3.141593F;
-            if(attackCounter > 0)
+            yBodyRot = yRot = (-(float) java.lang.Math.atan2(xd, zd) * 180F) / MathHelper.PI;
+            if(attackCharge > 0)
             {
-                attackCounter--;
+                attackCharge--;
             }
         }
         if(!world.isClientSide)
         {
             byte byte0 = entityData.getByte(16);
-            byte byte1 = (byte)(attackCounter <= 10 ? 0 : 1);
+            byte byte1 = (byte)(attackCharge <= 10 ? 0 : 1);
             if(byte0 != byte1)
             {
                 entityData.set(16, Byte.valueOf(byte1));
@@ -211,7 +220,7 @@ public class EntityGhast extends EntityFlying
         AABB axisalignedbb = bb.copy();
         for(int i = 1; (double)i < d3; i++)
         {
-            axisalignedbb.offset(d4, d5, d6);
+            axisalignedbb.move(d4, d5, d6);
             if(world.getCubes(this, axisalignedbb).size() > 0)
             {
                 return false;
@@ -267,9 +276,9 @@ public class EntityGhast extends EntityFlying
     }
 
     @Override
-	public boolean getCanSpawnHere()
+	public boolean canSpawnHere()
     {
-        return random.nextInt(20) == 0 && super.getCanSpawnHere() && world.difficultySetting > 0;
+        return random.nextInt(20) == 0 && super.canSpawnHere() && world.difficultySetting > 0;
     }
 
     @Override
@@ -277,13 +286,4 @@ public class EntityGhast extends EntityFlying
     {
         return 1;
     }
-
-    public int courseChangeCooldown;
-    public double waypointX;
-    public double waypointY;
-    public double waypointZ;
-    private Entity targetedEntity;
-    private int aggroCooldown;
-    public int prevAttackCounter;
-    public int attackCounter;
 }
diff --git a/src/main/java/net/minecraft/core/entity/monster/EntityGiant.java b/src/main/java/net/minecraft/core/entity/monster/GiantMob.java
similarity index 89%
rename from src/main/java/net/minecraft/core/entity/monster/EntityGiant.java
rename to src/main/java/net/minecraft/core/entity/monster/GiantMob.java
index c196c8446..85fb3d2f1 100644
--- a/src/main/java/net/minecraft/core/entity/monster/EntityGiant.java
+++ b/src/main/java/net/minecraft/core/entity/monster/GiantMob.java
@@ -7,10 +7,10 @@ package net.minecraft.core.entity.monster;
 import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.world.World;
 
-public class EntityGiant extends EntityMonster
+public class GiantMob extends Monster
 {
 
-    public EntityGiant(World world)
+    public GiantMob(World world)
     {
         super(world);
         textureIdentifier = new NamespaceID("minecraft", "zombie");
diff --git a/src/main/java/net/minecraft/core/entity/monster/EntityHuman.java b/src/main/java/net/minecraft/core/entity/monster/HumanMob.java
similarity index 90%
rename from src/main/java/net/minecraft/core/entity/monster/EntityHuman.java
rename to src/main/java/net/minecraft/core/entity/monster/HumanMob.java
index 8a62fdb3f..330b5975d 100644
--- a/src/main/java/net/minecraft/core/entity/monster/EntityHuman.java
+++ b/src/main/java/net/minecraft/core/entity/monster/HumanMob.java
@@ -6,9 +6,9 @@ import net.minecraft.core.util.helper.GetMonsterSkinUrlThread;
 import net.minecraft.core.world.World;
 
 
-public class EntityHuman extends EntityMonster
+public class HumanMob extends Monster
 {
-    public EntityHuman(World world)
+    public HumanMob(World world)
     {
         super(world);
 
diff --git a/src/main/java/net/minecraft/core/entity/monster/EntityMonster.java b/src/main/java/net/minecraft/core/entity/monster/Monster.java
similarity index 81%
rename from src/main/java/net/minecraft/core/entity/monster/EntityMonster.java
rename to src/main/java/net/minecraft/core/entity/monster/Monster.java
index 2b6ba2314..d36825af4 100644
--- a/src/main/java/net/minecraft/core/entity/monster/EntityMonster.java
+++ b/src/main/java/net/minecraft/core/entity/monster/Monster.java
@@ -5,21 +5,21 @@ package net.minecraft.core.entity.monster;
 //            AxisAlignedBB, MathHelper, EnumSkyBlock, NBTTagCompound
 
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.EntityPathfinder;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.PathfinderMob;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.util.helper.MathHelper;
 import com.mojang.nbt.CompoundTag;
-import net.minecraft.core.util.phys.Vec3d;
+import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.World;
 import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.core.world.season.Seasons;
 
-public abstract class EntityMonster extends EntityPathfinder
-    implements IEnemy
+public abstract class Monster extends PathfinderMob
+    implements Enemy
 {
 
-    public EntityMonster(World world)
+    public Monster(World world)
     {
         super(world);
         attackStrength = 2;
@@ -29,7 +29,7 @@ public abstract class EntityMonster extends EntityPathfinder
         return 20;
     }
     @Override
-    protected void updatePlayerActionState()
+    protected void updateAI()
     {
         if(closestFireflyEntity == null) {
             closestFireflyEntity = getClosestFireflyToEntity((int) x, (int) y, (int) z, 8F);
@@ -45,11 +45,11 @@ public abstract class EntityMonster extends EntityPathfinder
             dX = dX * scaleFactor;
             dZ = dZ * scaleFactor;
 
-            Vec3d distanceXYZ = Vec3d.createVector(x + dX, y, z + dZ);
-            pathToEntity = world.getEntityPathToXYZ(this, MathHelper.floor_double(distanceXYZ.xCoord), MathHelper.floor_double(y), MathHelper.floor_double(distanceXYZ.zCoord), 16F);
+            Vec3 distanceXYZ = Vec3.getTempVec3(x + dX, y, z + dZ);
+            pathToEntity = world.getEntityPathToXYZ(this, MathHelper.floor(distanceXYZ.x), MathHelper.floor(y), MathHelper.floor(distanceXYZ.z), 16F);
         }
 
-    super.updatePlayerActionState();
+    super.updateAI();
     }
 
     @Override
@@ -76,7 +76,7 @@ public abstract class EntityMonster extends EntityPathfinder
     @Override
 	protected Entity findPlayerToAttack()
     {
-        EntityPlayer entityplayer = world.getClosestPlayerToEntity(this, 16D);
+        Player entityplayer = world.getClosestPlayerToEntity(this, 16D);
         if(entityplayer != null && canEntityBeSeen(entityplayer) && entityplayer.getGamemode().areMobsHostile())
         {
             return entityplayer;
@@ -145,11 +145,11 @@ public abstract class EntityMonster extends EntityPathfinder
     }
 
     @Override
-	public boolean getCanSpawnHere()
+	public boolean canSpawnHere()
     {
-        int i = MathHelper.floor_double(x);
-        int j = MathHelper.floor_double(bb.minY);
-        int k = MathHelper.floor_double(z);
+        int i = MathHelper.floor(x);
+        int j = MathHelper.floor(bb.minY);
+        int k = MathHelper.floor(z);
         if(world.getSavedLightValue(LightLayer.Block, i, j, k) > 0) return false;
         if(world.getSavedLightValue(LightLayer.Sky, i, j, k) > random.nextInt(32))
             return false;
@@ -158,7 +158,7 @@ public abstract class EntityMonster extends EntityPathfinder
         if(world.getCurrentWeather() != null && world.getCurrentWeather().doMobsSpawnInDaylight)
             blockLight = blockLight/2;
 
-        return blockLight <= 4 && super.getCanSpawnHere();
+        return blockLight <= 4 && super.canSpawnHere();
     }
 
     protected int attackStrength;
diff --git a/src/main/java/net/minecraft/core/entity/monster/EntityScorpion.java b/src/main/java/net/minecraft/core/entity/monster/ScorpionMob.java
similarity index 82%
rename from src/main/java/net/minecraft/core/entity/monster/EntityScorpion.java
rename to src/main/java/net/minecraft/core/entity/monster/ScorpionMob.java
index 8cb38c277..175288368 100644
--- a/src/main/java/net/minecraft/core/entity/monster/EntityScorpion.java
+++ b/src/main/java/net/minecraft/core/entity/monster/ScorpionMob.java
@@ -6,39 +6,39 @@ package net.minecraft.core.entity.monster;
 
 import net.minecraft.core.WeightedRandomLootObject;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.item.Item;
+import net.minecraft.core.item.Items;
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.world.World;
 
-public class EntityScorpion extends EntityMonster
+public class ScorpionMob extends Monster
 {
 
-    public EntityScorpion(World world)
+    public ScorpionMob(World world)
     {
         super(world);
         textureIdentifier = new NamespaceID("minecraft", "scorpion");
         setSize(1F, 0.2F);
         moveSpeed = 0.8F;
         scoreValue = 200;
-        mobDrops.add(new WeightedRandomLootObject(Item.string.getDefaultStack(), 0, 2));
+        mobDrops.add(new WeightedRandomLootObject(Items.STRING.getDefaultStack(), 0, 2));
     }
 
     @Override
-	protected void init()
+	protected void defineSynchedData()
     {
-        super.init();
+        super.defineSynchedData();
         entityData.define(16, (byte) 1);
 
     }
     @Override
 	public void spawnInit()
     {
-        super.init();
+        super.defineSynchedData();
         if(world.difficultySetting != 0 && random.nextInt(100 / world.difficultySetting) == 0) {
-            EntitySkeleton entityskeleton = new EntitySkeleton(world);
+            SkeletonMob entityskeleton = new SkeletonMob(world);
             entityskeleton.moveTo(x, y, z, yRot, 0.0F);
             world.entityJoinedWorld(entityskeleton);
             entityskeleton.startRiding(this);
@@ -65,7 +65,7 @@ public class EntityScorpion extends EntityMonster
         if(f < 0.5F)
         {
             double d = 16D;
-            EntityPlayer p = world.getClosestPlayerToEntity(this, d);
+            Player p = world.getClosestPlayerToEntity(this, d);
             if (p != null)
             {
             	if (!p.gamemode.areMobsHostile()) return null;
@@ -110,9 +110,9 @@ public class EntityScorpion extends EntityMonster
             {
                 double d = entity.x - x;
                 double d1 = entity.z - z;
-                float f2 = MathHelper.sqrt_double(d * d + d1 * d1);
-                xd = (d / (double)f2) * 0.5D * 0.80000001192092896D + xd * 0.20000000298023224D;
-                zd = (d1 / (double)f2) * 0.5D * 0.80000001192092896D + zd * 0.20000000298023224D;
+                float f2 = MathHelper.sqrt(d * d + d1 * d1);
+                xd = (d / (double)f2) * 0.5D * 0.80000001192092896D + xd * 0.2D;
+                zd = (d1 / (double)f2) * 0.5D * 0.80000001192092896D + zd * 0.2D;
                 yd = 0.40000000596046448D;
             }
         } else
diff --git a/src/main/java/net/minecraft/core/entity/monster/EntitySkeleton.java b/src/main/java/net/minecraft/core/entity/monster/SkeletonMob.java
similarity index 71%
rename from src/main/java/net/minecraft/core/entity/monster/EntitySkeleton.java
rename to src/main/java/net/minecraft/core/entity/monster/SkeletonMob.java
index 8deb6a437..006930fd6 100644
--- a/src/main/java/net/minecraft/core/entity/monster/EntitySkeleton.java
+++ b/src/main/java/net/minecraft/core/entity/monster/SkeletonMob.java
@@ -2,29 +2,29 @@ package net.minecraft.core.entity.monster;
 
 // Referenced classes of package net.minecraft.src:
 //            EntityMob, World, MathHelper, Entity, 
-//            EntityArrow, Item, ItemStack, NBTTagCompound
+//            ArrowProjectile, Item, ItemStack, NBTTagCompound
 
 import net.minecraft.core.WeightedRandomLootObject;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.projectile.EntityArrow;
-import net.minecraft.core.item.Item;
+import net.minecraft.core.entity.projectile.ArrowProjectile;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.util.helper.MathHelper;
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.weather.Weather;
+import net.minecraft.core.world.weather.Weathers;
 
-public class EntitySkeleton extends EntityMonster
+public class SkeletonMob extends Monster
 {
 
-    public EntitySkeleton(World world)
+    public SkeletonMob(World world)
     {
         super(world);
         textureIdentifier = new NamespaceID("minecraft", "skeleton");
         scoreValue = 500;
-        mobDrops.add(new WeightedRandomLootObject(Item.ammoArrow.getDefaultStack(), 0, 2));
-        mobDrops.add(new WeightedRandomLootObject(Item.bone.getDefaultStack(), 0, 2));
+        mobDrops.add(new WeightedRandomLootObject(Items.AMMO_ARROW.getDefaultStack(), 0, 2));
+        mobDrops.add(new WeightedRandomLootObject(Items.BONE.getDefaultStack(), 0, 2));
     }
 
     @Override
@@ -45,9 +45,9 @@ public class EntitySkeleton extends EntityMonster
         return "mob.skeletonhurt";
     }
     @Override
-    protected void init()
+    protected void defineSynchedData()
     {
-        super.init();
+        super.defineSynchedData();
         entityData.define(15, attackTime);
     }
 
@@ -62,8 +62,8 @@ public class EntitySkeleton extends EntityMonster
         if(world.isDaytime())
         {
             float f = getBrightness(1.0F);
-            if(f > 0.5F && world.canBlockSeeTheSky(MathHelper.floor_double(x), MathHelper.floor_double(y), MathHelper.floor_double(z)) && random.nextFloat() * 30F < (f - 0.4F) * 2.0F
-             && (world.getCurrentWeather() != Weather.overworldFog || world.weatherManager.getWeatherPower() < 0.75F))
+            if(f > 0.5F && world.canBlockSeeTheSky(MathHelper.floor(x), MathHelper.floor(y), MathHelper.floor(z)) && random.nextFloat() * 30F < (f - 0.4F) * 2.0F
+             && (world.getCurrentWeather() != Weathers.OVERWORLD_FOG || world.weatherManager.getWeatherPower() < 0.75F))
             {
                 remainingFireTicks = 300;
             }
@@ -81,17 +81,17 @@ public class EntitySkeleton extends EntityMonster
             if(attackTime == 0)
             {
                 if(!world.isClientSide) {
-                    EntityArrow entityarrow = new EntityArrow(world, this, false, 0);
+                    ArrowProjectile entityarrow = new ArrowProjectile(world, this, false, 0);
                     entityarrow.y += 1.3999999761581421D;
-                    double d2 = (entity.y + (double) entity.getHeadHeight()) - 0.20000000298023224D - entityarrow.y;
-                    float f1 = MathHelper.sqrt_double(d * d + d1 * d1) * 0.2F;
+                    double d2 = (entity.y + (double) entity.getHeadHeight()) - 0.2D - entityarrow.y;
+                    float f1 = MathHelper.sqrt(d * d + d1 * d1) * 0.2F;
                     world.playSoundAtEntity(null, this, "random.bow", 1.0F, 1.0F / (random.nextFloat() * 0.4F + 0.8F));
                     entityarrow.setHeading(d, d2 + (double) f1, d1, 0.6F, 12F);
                     world.entityJoinedWorld(entityarrow);
                 }
                 attackTime = 30;
             }
-            yRot = (float)((java.lang.Math.atan2(d1, d) * 180D) / 3.1415927410125732D) - 90F;
+            yRot = (float)((java.lang.Math.atan2(d1, d) * 180D) / Math.PI) - 90F;
             hasAttacked = true;
         }
     }
@@ -118,6 +118,6 @@ public class EntitySkeleton extends EntityMonster
 
     static 
     {
-        defaultHeldItem = new ItemStack(Item.toolBow, 1);
+        defaultHeldItem = new ItemStack(Items.TOOL_BOW, 1);
     }
 }
